KFileItem Class Reference

`#include <kfileitem.h>`

## Public Types

enum | { Unknown = (mode_t) - 1 }

## Public Member Functions

| KFileItem (const KIO::UDSEntry &_entry, const KURL &_url, bool _determineMimeTypeOnDemand=false, bool _urlIsDirectory=false)
| KFileItem (mode_t _mode, mode_t _permissions, const KURL &_url, bool _determineMimeTypeOnDemand=false)
| KFileItem (const KURL &url, const QString &mimeType, mode_t mode)
| KFileItem (const KFileItem &item)
virtual | ~KFileItem ()
void | refresh ()
void | refreshMimeType ()
const KURL & | url () const
void | setURL (const KURL &url)
void | setName (const QString &name)
mode_t | permissions () const
QString | permissionsString () const
bool | hasExtendedACL () const
KACL | ACL () const
KACL | defaultACL () const
mode_t | mode () const
QString | user () const
QString | group () const
bool | isLink () const
bool | isDir () const
bool | isFile () const
bool | isReadable () const
bool | isWritable () const
bool | isHidden () const
QString | linkDest () const
QString | localPath () const
KIO::filesize_t | size () const
KIO::filesize_t | size (bool &hasSize) const
time_t | time (unsigned int which) const
time_t | time (unsigned int which, bool &hasTime) const
QString | timeString (unsigned int which=KIO::UDS_MODIFICATION_TIME) const
bool | isLocalFile () const
const QString & | text () const
const QString & | name (bool lowerCase=false) const
QString | mimetype () const
KMimeType::Ptr | determineMimeType ()
KMimeType::Ptr | mimeTypePtr () const
bool | isMimeTypeKnown () const
QString | mimeComment ()
QString | iconName ()
QPixmap | pixmap (int _size, int _state=0) const
int | overlays () const
QString | getStatusBarInfo ()
QString | getToolTipText (int maxcount=6)
bool | acceptsDrops ()
void | run ()
const KIO::UDSEntry & | entry () const
bool | isMarked () const
void | mark ()
void | unmark ()
bool | cmp (const KFileItem &item)
virtual void | setExtraData (const void *key, void *value)
virtual const void * | extraData (const void *key) const
virtual void * | extraData (const void *key)
virtual void | removeExtraData (const void *key)
void | setMetaInfo (const KFileMetaInfo &info)
void | setFileMode (mode_t m)
void | setMimeType (const QString &mimetype)
const KFileMetaInfo & | metaInfo (bool autoget=true, int what=KFileMetaInfo::Fastest) const
void | assign (const KFileItem &item)
void | setUDSEntry (const KIO::UDSEntry &entry, const KURL &url, bool determineMimeTypeOnDemand=false, bool urlIsDirectory=false)
KFileItem & | operator= (const KFileItem &)
KURL | mostLocalURL (bool &local) const

## Protected Member Functions

void | init (bool _determineMimeTypeOnDemand)
void | readUDSEntry (bool _urlIsDirectory)
QString | parsePermissions (mode_t perm) const
virtual void | virtual_hook (int id, void *data)

## Friends

KIO_EXPORT friend QDataStream & | operator<< (QDataStream &s, const KFileItem &a)
KIO_EXPORT friend QDataStream & | operator>> (QDataStream &s, KFileItem &a)

## Detailed Description

A KFileItem is a generic class to handle a file, local or remote.

In particular, it makes it easier to handle the result of KIO::listDir (UDSEntry isn't very friendly to use). It includes many file attributes such as mimetype, icon, text, mode, link...

Definition at line 41 of file kfileitem.h.

## Constructor & Destructor Documentation

KFileItem::KFileItem | ( | const KIO::UDSEntry & | _entry,
|  | const KURL & | _url,
|  | bool | _determineMimeTypeOnDemand = `false`,
|  | bool | _urlIsDirectory = `false`
| ) |  |

Creates an item representing a file, from a UDSEntry.

This is the preferred constructor when using KIO::listDir().

Parameters

  _entry | the KIO entry used to get the file, contains info about it
  _url | the file url
  _determineMimeTypeOnDemand | specifies if the mimetype of the given URL should be determined immediately or on demand
  _urlIsDirectory | specifies if the url is just the directory of the fileitem and the filename from the UDSEntry should be used.

Definition at line 54 of file kfileitem.cpp.

KFileItem::KFileItem | ( | mode_t | _mode,
|  | mode_t | _permissions,
|  | const KURL & | _url,
|  | bool | _determineMimeTypeOnDemand = `false`
| ) |  |

Creates an item representing a file, from all the necessary info for it.

Parameters

  _mode | the file mode (according to stat() (e.g. S_IFDIR...) Set to KFileItem::Unknown if unknown. For local files, KFileItem will use stat().
  _permissions | the access permissions If you set both the mode and the permissions, you save a ::stat() for local files. Set to KFileItem::Unknown if you don't know the mode or the permission.
  _url | the file url
  _determineMimeTypeOnDemand | specify if the mimetype of the given URL should be determined immediately or on demand

Definition at line 72 of file kfileitem.cpp.

KFileItem::KFileItem | ( | const KURL & | url,
|  | const QString & | mimeType,
|  | mode_t | mode
| ) |  |

Creates an item representing a file, for which the mimetype is already known.

Parameters

  url | the file url
  mimeType | the name of the file's mimetype
  mode | the mode (S_IFDIR...)

Definition at line 90 of file kfileitem.cpp.

KFileItem::KFileItem | ( | const KFileItem & | item | ) |

Copy constructor.

Note that extra-data set via setExtraData() is not deeply copied – just the pointers are copied.

Definition at line 110 of file kfileitem.cpp.

KFileItem::~KFileItem | ( |  | ) |

virtual

Destructs the KFileItem.

Extra data set via setExtraData() is not deleted.

Definition at line 122 of file kfileitem.cpp.

## Member Function Documentation

bool KFileItem::acceptsDrops | ( |  | ) |

Returns true if files can be dropped over this item.

Contrary to popular belief, not only dirs will return true :) Executables, .desktop files, will do so as well.

Returns
  true if you can drop files over the item

Definition at line 700 of file kfileitem.cpp.

KACL KFileItem::ACL | ( |  | ) | const

Returns the access control list for the file.

Returns
  the access control list as a KACL

Since
  3.5

Definition at line 370 of file kfileitem.cpp.

void KFileItem::assign | ( | const KFileItem & | item | ) |

Somewhat like an assignment operator, but more explicit.

Note: extra-data set with setExtraData() is not copied, so be careful what you do!

Parameters

  item | the item to copy

Definition at line 872 of file kfileitem.cpp.

bool KFileItem::cmp | ( | const KFileItem & | item | ) |

Somewhat like a comparison operator, but more explicit.

Parameters

  item | the item to compare

Returns
  true if all values are equal

Definition at line 850 of file kfileitem.cpp.

KACL KFileItem::defaultACL | ( |  | ) | const

Returns the default access control list for the directory.

Returns
  the default access control list as a KACL

Since
  3.5

Definition at line 383 of file kfileitem.cpp.

KMimeType::Ptr KFileItem::determineMimeType | ( |  | ) |

Returns the mimetype of the file item.

If _determineMimeTypeOnDemand was used in the constructor, this will determine the mimetype first.

Returns
  the mime type

Definition at line 498 of file kfileitem.cpp.

const KIO::UDSEntry& KFileItem::entry | ( |  | ) | const

inline

Returns the UDS entry.

Used by the tree view to access all details by position.

Returns
  the UDS entry

Definition at line 399 of file kfileitem.h.

const void * KFileItem::extraData | ( | const void * | key | ) | const

virtual

Retrieves the extra data with the given `key`.

Parameters

  key | the key of the extra data

Returns
  the extra data associated to an item with `key` via setExtraData. 0L if nothing was associated with `key`.

See also
  extraData

Definition at line 958 of file kfileitem.cpp.

void * KFileItem::extraData | ( | const void * | key | ) |

virtual

Retrieves the extra data with the given `key`.

Parameters

  key | the key of the extra data

Returns
  the extra data associated to an item with `key` via setExtraData. 0L if nothing was associated with `key`.

See also
  extraData

Definition at line 966 of file kfileitem.cpp.

QString KFileItem::getStatusBarInfo | ( |  | ) |

Returns the string to be displayed in the statusbar, e.g.

when the mouse is over this item

Returns
  the status bar information

Definition at line 721 of file kfileitem.cpp.

QString KFileItem::getToolTipText | ( | int | maxcount = `6` | ) |

Returns the string to be displayed in the tool tip when the mouse is over this item.

This may load a plugin to determine additional information specific to the mimetype of the file.

Parameters

  maxcount | the maximum number of entries shown

Returns
  the tool tip string

Definition at line 760 of file kfileitem.cpp.

QString KFileItem::group | ( |  | ) | const

Returns the group of the file.

Returns
  the file's group

Definition at line 471 of file kfileitem.cpp.

bool KFileItem::hasExtendedACL | ( |  | ) | const

Tells if the file has extended access level information ( Posix ACL )

Returns
  true if the file has extend ACL information or false if it hasn't

Since
  3.5

Definition at line 360 of file kfileitem.cpp.

QString KFileItem::iconName | ( |  | ) |

Returns the full path name to the icon that represents this mime type.

Returns
  iconName the name of the file's icon

Definition at line 536 of file kfileitem.cpp.

void KFileItem::init | ( | bool | _determineMimeTypeOnDemand | ) |

protected

Computes the text, mode, and mimetype from the UDSEntry Called by constructor, but can be called again later.

Definition at line 127 of file kfileitem.cpp.

bool KFileItem::isDir | ( |  | ) | const

Returns true if this item represents a directory.

Returns
  true if the item is a directory

Definition at line 682 of file kfileitem.cpp.

bool KFileItem::isFile | ( |  | ) | const

inline

Returns true if this item represents a file (and not a a directory)

Returns
  true if the item is a file

Definition at line 198 of file kfileitem.h.

bool KFileItem::isHidden | ( |  | ) | const

Checks whether the file is hidden.

Returns
  true if the file is hidden.

Definition at line 671 of file kfileitem.cpp.

bool KFileItem::isLink | ( |  | ) | const

inline

Returns true if this item represents a link in the UNIX sense of a link.

Returns
  true if the file is a link

Definition at line 186 of file kfileitem.h.

bool KFileItem::isLocalFile | ( |  | ) | const

inline

Returns true if the file is a local file.

Returns
  true if the file is local, false otherwise

Definition at line 282 of file kfileitem.h.

bool KFileItem::isMarked | ( |  | ) | const

inline

Used when updating a directory.

marked == seen when refreshing.

Returns
  true if the file item is marked

Definition at line 405 of file kfileitem.h.

bool KFileItem::isReadable | ( |  | ) | const

Checks whether the file or directory is readable.

In some cases (remote files), we may return true even though it can't be read.

Returns
  true if the file can be read - more precisely, false if we know for sure it can't

Definition at line 621 of file kfileitem.cpp.

bool KFileItem::isWritable | ( |  | ) | const

Checks whether the file or directory is writable.

In some cases (remote files), we may return true even though it can't be written to.

Returns
  true if the file or directory can be written to - more precisely, false if we know for sure it can't

Since
  3.4

Definition at line 648 of file kfileitem.cpp.

QString KFileItem::linkDest | ( |  | ) | const

Returns the link destination if isLink() == true.

Returns
  the link destination. QString::null if the item is not a link

Definition at line 296 of file kfileitem.cpp.

QString KFileItem::localPath | ( |  | ) | const

Returns the local path if isLocalFile() == true or the KIO item has a UDS_LOCAL_PATH atom.

Returns
  the item local path, or QString::null if not known

Since
  3.4

Definition at line 317 of file kfileitem.cpp.

void KFileItem::mark | ( |  | ) |

inline

Marks the item.

See also
  isMarked()

Definition at line 410 of file kfileitem.h.

const KFileMetaInfo & KFileItem::metaInfo | ( | bool | autoget = `true`,
|  | int | what = `KFileMetaInfo::Fastest`
| ) |  | const

Returns the metainfo of this item.

Parameters

  autoget | if true, the metainfo will automatically be created
  what | ignored

Definition at line 1043 of file kfileitem.cpp.

QString KFileItem::mimeComment | ( |  | ) |

Returns the descriptive comment for this mime type, or the mime type itself if none is present.

Returns
  the mime type description, or the mime type itself

Definition at line 521 of file kfileitem.cpp.

QString KFileItem::mimetype | ( |  | ) | const

Returns the mimetype of the file item.

If `_determineMimeTypeOnDemand` was used in the constructor, this will determine the mimetype first. Equivalent to determineMimeType()->name()

Returns
  the mime type of the file

Definition at line 492 of file kfileitem.cpp.

KMimeType::Ptr KFileItem::mimeTypePtr | ( |  | ) | const

inline

Returns the currently known mimetype of the file item.

This will not try to determine the mimetype if unknown.

Returns
  the known mime type

Definition at line 328 of file kfileitem.h.

mode_t KFileItem::mode | ( |  | ) | const

inline

Returns the file type (stat.st_mode containing only S_IFDIR, S_IFLNK, ...).

Returns
  the file type

Definition at line 167 of file kfileitem.h.

KURL KFileItem::mostLocalURL | ( | bool & | local | ) | const

Tries to give a local URL for this file item if possible.

The given boolean indicates if the returned url is local or not.

Definition at line 1057 of file kfileitem.cpp.

const QString& KFileItem::name | ( | bool | lowerCase = `false` | ) | const

inline

Return the name of the file item (without a path).

Similar to text(), but unencoded, i.e. the original name.

Parameters

  lowerCase | if true, the name will be returned in lower case, which is useful to speed up sorting by name, case insensitively.

Returns
  the file's name

Definition at line 298 of file kfileitem.h.

KFileItem & KFileItem::operator= | ( | const KFileItem & | item | ) |

Assignment operator, calls assign()

Definition at line 116 of file kfileitem.cpp.

int KFileItem::overlays | ( |  | ) | const

Returns the overlays (bitfield of KIcon::*Overlay flags) that are used for this item's pixmap.

Overlays are used to show for example, whether a file can be modified.

Returns
  the overlays of the pixmap

Definition at line 547 of file kfileitem.cpp.

QString KFileItem::parsePermissions | ( | mode_t | perm | ) | const

protected

Parses the given permission set and provides it for access()

Definition at line 987 of file kfileitem.cpp.

mode_t KFileItem::permissions | ( |  | ) | const

inline

Returns the permissions of the file (stat.st_mode containing only permissions).

Returns
  the permissions of the file

Definition at line 134 of file kfileitem.h.

QString KFileItem::permissionsString | ( |  | ) | const

Returns the access permissions for the file as a string.

Returns
  the access persmission as string

Definition at line 979 of file kfileitem.cpp.

QPixmap KFileItem::pixmap | ( | int | _size,
|  | int | _state = `0`
| ) |  | const

Returns a pixmap representing the file.

Parameters

  _size | Size for the pixmap in pixels. Zero will return the globally configured default size.
  _state | The state of the icon: KIcon::DefaultState, KIcon::ActiveState or KIcon::DisabledState.

Returns
  the pixmap

Definition at line 575 of file kfileitem.cpp.

void KFileItem::readUDSEntry | ( | bool | _urlIsDirectory | ) |

protected

Extracts the data from the UDSEntry member and updates the KFileItem accordingly.

Since
  3.4.1

Definition at line 189 of file kfileitem.cpp.

void KFileItem::refresh | ( |  | ) |

Throw away and re-read (for local files) all information about the file.

This is called when the file changes.

Definition at line 260 of file kfileitem.cpp.

void KFileItem::refreshMimeType | ( |  | ) |

Re-reads mimetype information.

This is called when the mimetype database changes.

Definition at line 278 of file kfileitem.cpp.

void KFileItem::removeExtraData | ( | const void * | key | ) |

virtual

Removes the extra data associated with an item via `key`.

Parameters

  key | the key of the extra data to remove

Definition at line 974 of file kfileitem.cpp.

void KFileItem::run | ( |  | ) |

Let's "KRun" this file ! (e.g.

when file is clicked or double-clicked or return is pressed)

Definition at line 842 of file kfileitem.cpp.

void KFileItem::setExtraData | ( | const void * | key,
|  | void * | value
| ) |  |

virtual

This allows to associate some "extra" data to a KFileItem.

As one KFileItem can be used by several objects (often views) which all need to add some data, you have to use a key to reference your extra data within the KFileItem.

That way a KFileItem can hold and provide access to all those views separately.

I.e. a KFileIconView that associates a KFileIconViewItem (an item suitable for use with QIconView) does

kfileItem->setExtraData( this, iconViewItem );

and can later access the iconViewItem by doing

KFileIconViewItem *iconViewItem = static_cast<KFileIconViewItem*>( kfileItem->extraData( this ));

This is usually more efficient then having every view associate data to items by using a separate QDict or QMap.

Note: you have to remove and destroy the data you associated yourself when you don't need it anymore!

Parameters

  key | the key of the extra data
  value | the value of the extra data

See also
  extraData
  removeExtraData

Definition at line 950 of file kfileitem.cpp.

void KFileItem::setFileMode | ( | mode_t | m | ) |

Sets the file type (stat.st_mode containing only S_IFDIR, S_IFLNK, ...).

Parameters

  m | the new file type

Since
  3.5.0

Todo:
  Actually explain what this does – does setting S_IFDIR mean the file type is set to Directory?

Definition at line 940 of file kfileitem.cpp.

void KFileItem::setMetaInfo | ( | const KFileMetaInfo & | info | ) |

Sets the metainfo of this item to `info`.

Parameters

  info | the new meta info

Definition at line 1038 of file kfileitem.cpp.

void KFileItem::setMimeType | ( | const QString & | mimetype | ) |

Sets new mimetype for item.

Parameters

  mimetype | the new mimetype

Since
  3.5.0

Definition at line 945 of file kfileitem.cpp.

void KFileItem::setName | ( | const QString & | name | ) |

Sets the item's name (i.e.

the filename). This is automatically done by setURL, to set the name from the URL's fileName(). This method is provided for some special cases like relative paths as names (KFindPart)

Parameters

  name | the item's name

Definition at line 290 of file kfileitem.cpp.

void KFileItem::setUDSEntry | ( | const KIO::UDSEntry & | entry,
|  | const KURL & | url,
|  | bool | determineMimeTypeOnDemand = `false`,
|  | bool | urlIsDirectory = `false`
| ) |  |

Reinitialize KFileItem with a new UDSEntry.

Note: extra-data set with setExtraData() is not changed or deleted, so be careful what you do!

KDirListerCache uses it to save new/delete calls by updating existing items that are otherwise not needed anymore.

Parameters

  entry | the UDSEntry to assign to this KFileItem
  url | the file url
  determineMimeTypeOnDemand | specifies if the mimetype of the given URL should be determined immediately or on demand
  urlIsDirectory | specifies if the url is just the directory of the fileitem and the filename from the UDSEntry should be used.

Since
  3.4.1

Definition at line 912 of file kfileitem.cpp.

void KFileItem::setURL | ( | const KURL & | url | ) |

Sets the item's URL.

Do not call unless you know what you are doing! (used for example when an item got renamed).

Parameters

  url | the item's URL

Definition at line 284 of file kfileitem.cpp.

KIO::filesize_t KFileItem::size | ( |  | ) | const

Returns the size of the file, if known.

Returns
  the file size, or 0 if not known

Definition at line 393 of file kfileitem.cpp.

KIO::filesize_t KFileItem::size | ( | bool & | hasSize | ) | const

Returns the size of the file, if known, and sets `hasSize` to false if not known.

Parameters

  | hasSize This is set to true if the size is known, and false if not known

Returns
  the file size, or 0 if not known

Definition at line 336 of file kfileitem.cpp.

const QString& KFileItem::text | ( |  | ) | const

inline

Returns the text of the file item.

It's not exactly the filename since some decoding happens ('%2F'->'/').

Returns
  the text of the file item

Definition at line 289 of file kfileitem.h.

time_t KFileItem::time | ( | unsigned int | which | ) | const

Requests the modification, access or creation time, depending on `which`.

Parameters

  which | UDS_MODIFICATION_TIME, UDS_ACCESS_TIME or UDS_CREATION_TIME

Returns
  the time asked for, (time_t)0 if not available

See also
  timeString()

Definition at line 399 of file kfileitem.cpp.

time_t KFileItem::time | ( | unsigned int | which,
|  | bool & | hasTime
| ) |  | const

Requests the modification, access or creation time, depending on `which`.

Parameters

  which | UDS_MODIFICATION_TIME, UDS_ACCESS_TIME or UDS_CREATION_TIME
  hasTime | This is set to true is the time is known, and false if not known

Returns
  the time asked for, (time_t)0 if not known/available

See also
  timeString()

Definition at line 404 of file kfileitem.cpp.

QString KFileItem::timeString | ( | unsigned int | which = `KIO::UDS_MODIFICATION_TIME` | ) | const

Requests the modification, access or creation time as a string, depending on `which`.

Parameters

  which | UDS_MODIFICATION_TIME, UDS_ACCESS_TIME or UDS_CREATION_TIME

Returns
  a formatted string of the requested time, QString::null if time is not known

See also
  time

Definition at line 1027 of file kfileitem.cpp.

void KFileItem::unmark | ( |  | ) |

inline

Unmarks the item.

See also
  isMarked()

Definition at line 415 of file kfileitem.h.

const KURL& KFileItem::url | ( |  | ) | const

inline

Returns the url of the file.

Returns
  the url of the file

Definition at line 113 of file kfileitem.h.

QString KFileItem::user | ( |  | ) | const

Returns the owner of the file.

Returns
  the file's owner

Definition at line 456 of file kfileitem.cpp.

The documentation for this class was generated from the following files:

- kfileitem.h
- kfileitem.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys